#pragma once
#include <arduino.h>
#include <avr/pgmspace.h>
#include <EEPROM.h>
#include "settings.h"

#define MEM_MAX_SIZE ((EEPROM_SIZE-EEPROM_MEM_OFFSET)/NR_OF_MEMORY_BUTTONS)
#define MEM_MAX_BITS ((MEM_MAX_SIZE-1)*8)

class Memory
{
  private:
  
  int m_MemIndex;
  int m_Position;
  char m_Bits;
  
  //unsigned char m_Memory[NR_OF_MEMORY_BUTTONS][MEM_MAX_SIZE];

  void addChar( char c );

  bool getMemBit();
  void setMemBit( bool bit );
  
  public:

  enum SYMBOLS
  {
    DIT,
    DAH,
    CPAUSE,
    WPAUSE,
    END
  };
  
  void init( bool reset );
 
  void setMemory( int memIndex );
  SYMBOLS getSymbol();
  bool addSymbol( int symbol );
  void flushMemBits();

  void sendMemory( int memIndex );
  
  void setString( int memIndex, char const * const string );
  void setString( int memIndex, __FlashStringHelper const * const data );

  void updateLoop( int memIndex );
};
