// morse-code-characters for dl1smf-uno-keyer
//
// The used encoding is as follows:
//
// A "dit" is stored as a set bit and a "dah" is stored as
// an unset bit. The lowest bit represents the first and the
// highest bit represents the last symbol. Every character
// ends with a set bit. 
//
// Example:
// Letter "A" .-   is encoded as 0b00000101
// Letter "B" -... is encoded as 0b00011110

// The table will be located in PROGMEM. So it does not kill
// precious dynamic SRAM space. For this we need to include 
// the AVR pgmspace.h

#include <avr/pgmspace.h>

// just make sure, that this only is included once
#pragma once

class Morse
{
    private:
    
    PROGMEM static unsigned char const m_MorseTable[];

    public:

    unsigned char toMorse( unsigned char c );
    unsigned char toASCII( unsigned char m );
  };

